<?php

require_once ('bs_system_settings.php');  // Variable for site specific values (PM@Horizont, PM-Test, PM-Prod)   

$hos_config = array_merge ($hos_config,
array (
    /*
     *  It maps IP addresses of systems to constant ID, that must never be changed.
     *  You can change the name (is shown in select boxes), but you can never change id after it has been used
     *  for the first time. The application needs it to uniquely identify the system regardless of its IP address.
     */
		'system_mapping' => array(
			$bs_ip1 => array(
				array (
					'name' => $bs_BAS_name,
					'id'   => $bs_BAS_id  
				),
				array (
					'name' => $bs_DEV_name,
					'id'   => $bs_DEV_id  
				),
				array (
					'name' => $bs_INT_name,
					'id'   => $bs_INT_id  
				),
				array (
					'name' => $bs_UAT_name,
					'id'   => $bs_UAT_id  
				),
				array (
					'name' => $bs_PRD_name,
					'id'   => $bs_PRD_id  
				),
			),
		),  
		/*
		'system_mapping' => array(
			$bs_testsys => array(
				'name' => $bs_env.'-UAT',
				'id'   => $bs_uatid  
			)
		), 
		'system_mapping' => array(
			$bs_prodsys => array(
				'name' => $bs_env.'-PRO',
				'id'   => $bs_proid  
			)
		), 
        */
    /* defines environments and environment-dependent setting 
  */
	'environment' => array (
		'client' => array (
			'*'	=> array (
				'request'	=>	include ('hos_env_general.php')
			),
			'BS'	=> array (
				'request'	=>	array_merge (
					include ('hos_env_bs.php'),
					include ('hos_env_archive_bs.php'),
					include ('hos_env_develop_bs.php'),
					include ('hos_tws_env_bs.php'),
					include ('hos_tws_env_archive_bs.php'),
					include ('hos_tws_env_develop_bs.php')
				)
			)
		)
	),
    /* 
     *  technical users on various systems and for various handovers and actions.
     *  if no match is found, the current logged-in user is used 
     *  actions: * (i.e. any action)
     *           check
     *           read
     *           write
     *
   	 */
		'zos_tech_user' => array(
			$bs_BAS_id => array (
				'*' => array (            
					'user' => $bs_BAS_user,
					'pwd'  => $bs_BAS_psw,
					'actions' => array (
						'import' => false,
						'export' => false,
						'write' => true,
						'check' => true
					)                
				)
			),
			$bs_PRD_id => array (
				'*' => array (            
					'user' => $bs_PRD_user,
					'pwd'  => $bs_PRD_psw,
					'actions' => array (
						'import' => false,
						'export' => false,
						'write' => true,
						'check' => true
					)                
				)
			),
			$bs_UAT_id => array (
				'*' => array (            
					'user' => $bs_UAT_user,
					'pwd'  => $bs_UAT_psw,
					'actions' => array (
						'import' => false,
						'export' => false,
						'write' => true,
						'check' => true
					)                
				)
			),
			$bs_INT_id => array (
				'*' => array (            
					'user' => $bs_INT_user,
					'pwd'  => $bs_INT_psw,
					'actions' => array (
						'import' => false,
						'export' => false,
						'write' => true,
						'check' => true
					)                
				)
			),
			$bs_DEV_id => array (
				'*' => array (            
					'user' => $bs_DEV_user,
					'pwd'  => $bs_DEV_psw,
					'actions' => array (
						'import' => false,
						'export' => false,
						'write' => true,
						'check' => true
					)                
				)
			)			
		),
    /*
     *  code page of web pages 
     */
		'web_code_page' => 'utf-8',
		
    /*
     *  folder for temp files
     */
		'tmp_dir' => $hwi_config['hwi_root'] . "/tmp",
		
    /*
     *  logfile for script access
     */
        'script_access_log_file' => $hwi_config['log_dir'] . '/script_access.log',
		
    /*
     *  maximal number of records in a list view
     */
        'list_limit' => 1000,

    /* 
     *  Horcclnt ini file (configures communication with host modules)
     */
        'rot_ini_file' => array(
			$bs_BAS_id => $hwi_config ['hwi_root'].$bs_BAS_hor_ini,
            $bs_PRD_id => $hwi_config ['hwi_root'].$bs_PRD_hor_ini,
			$bs_UAT_id => $hwi_config ['hwi_root'].$bs_UAT_hor_ini,
			$bs_INT_id => $hwi_config ['hwi_root'].$bs_INT_hor_ini,
			$bs_DEV_id => $hwi_config ['hwi_root'].$bs_DEV_hor_ini
        ),
    /* 
     *  code page of data received from the host
     */
        'rot_client_code_page' => 'iso-8859-1',

    /*
     *  XINFO mapping: allows you to set table and column names for any target system 
     *  - if you specify both, the edited setting for concrete IP overwrites the general setting
     *    (the IP address has a meaning of the target system - the system where JCL is coppied in case of JclNew
     *     or the system on which the JCL is changed/deleted in case of JclChange/JclDel) 
     *
     *  - optionally you can define connection setting that overwrites the 'xinfo' DB conenction parameters defined
     *    by 'db' array above in this script. You can do it for any xinfo table on any target system
     *    you can define it for all table/system (if you specify *) or for concrete table and/or system
     *
     *  - optionally you can define system mapping. this allows you to recognize which data belongs to which systems
     *    in case you are merging data from two or more systems into one xinfo database.
     *    you can define three columns that are used by xinfo to find out the right system
     *    you can do it at general level (use *) and/or for concrete system or table
     */
	'xinfo' => array (
	    '*' => array (                  // target_system
	        '*' => array (            // client 
    	        'table' => array (
                    'XXRTDDF' => array (
                        'name' => $bs_xinfo_owner.'.'.$bs_xinfo_XXRTDDF,
                        'col'  => array (
                            'XXRDATCLIENT'  => 'XXRDATCLIENT',     // Client
                            'XXRDATENV'     => 'XXRDATENV',        // Environment
                            'XXRDATINFO'    => 'XXRDATINFO',       // DatAddInfo
                            'DDFJN'         => 'DDFJN',            // Jobname
                            'DDFSTEP#'      => 'DDFSTEP#',         // Stepnumber
                            'DDFPGMN'       => 'DDFPGMN',          // Programname
                            'DDFDDN'        => 'DDFDDN',           // DD-name
                            'DDFCC#'        => 'DDFCC#',           // Concat-number
                            'DDFDSN'        => 'DDFDSN',           // Dataset Name (deleted)
                            'DDFDSMEMBER'   => 'DDFDSMEMBER',      // Member/Generation (deleted)
                            'DDFLIB'        => 'DDFLIB',           // JCL-Lib
                            'DDFMEMB'       => 'DDFMEMB',          // Member
                            'DDFCALLEDPROC' => 'DDFCALLEDPROC',    // Called Procedure
                            'DDFCALLEDLIB'  => 'DDFCALLEDLIB'      // Proclib (called)
                        )                     
                    ),

                    'XXRTEXE' => array (
                        'name' => $bs_xinfo_owner.'.'.$bs_xinfo_XXRTEXE,
                        'col'  => array (
                            'XXRDATCLIENT' => 'XXRDATCLIENT',      // Client
                            'XXRDATENV'    => 'XXRDATENV',         // Environment
                            'XXRDATINFO'   => 'XXRDATINFO',        // DatAddInfo
                            'EXEJN'        => 'EXEJN',             // Jobname
                            'EXEMEMB'      => 'EXEMEMB',           // Member
                            'EXELIB'       => 'EXELIB',            // JCL-lib
                            'EXESTEP#'     => 'EXESTEP#',          // Stepnumber
                            'EXEPROCN'     => 'EXEPROCN',          // Procedurename
                            'EXECALLEDLIB' => 'EXECALLEDLIB',      // Proclib (called)
                            'EXETYPE'      => 'EXETYPE',           // Type (PROC/PGM)
                            'EXEJOBSN'     => 'EXEJOBSN'           // JobStepname
                        )
                    ),

                    'XXRTOP' => array (
                        'name' => $bs_xinfo_owner.'.'.$bs_xinfo_XXRTOP,
                        'col'  => array (
                            'XXRDATCLIENT' => 'XXRDATCLIENT',      // Client
                            'XXRDATENV'    => 'XXRDATENV',         // Environment
                            'XXRDATINFO'   => 'XXRDATINFO',        // DatAddInfo
                            'ADRID'        => 'ADRID',             // Application ID
                            'ADROPJN'      => 'ADROPJN',           // Jobname
                            'ADROPNO'      => 'ADROPNO',           // Operation Number
                            'ADRWSID'      => 'ADRWSID'	           // Workstation
                        )
                    ),

                    'XXRTDEP' => array (
                        'name' => $bs_xinfo_owner.'.'.$bs_xinfo_XXRTDEP,
                        'col'  => array (
                            'XXRDATCLIENT' => 'XXRDATCLIENT',      // Client
                            'XXRDATENV'    => 'XXRDATENV',         // Environment
                            'XXRDATINFO'   => 'XXRDATINFO',        // DatAddInfo
                            'ADROPEAD'     => 'ADROPEAD',          // Pred. Application
                            'ADROPEJN'     => 'ADROPEJN',          // Pred. Jobname
                            'ADREP_OPNO'   => 'ADREP_OPNO',        // Pred. Operation No.
                            'ADREP_WSID'   => 'ADREP_WSID',        // Pred. Workstation
                            'ADRID'        => 'ADRID',             // Application ID
                            'ADROPJN'      => 'ADROPJN',           // Jobname
                            'ADROPNO'      => 'ADROPNO',           // Operation Number
                            'ADRWSID'      => 'ADRWSID',           // Workstation
                            'ADRDEPEXT'    => 'ADRDEPEXT'          // Ext. Pred. Y/N/I/E
                        )
                    ),
                    
                    'XXRTJOB' => array (
                        'name' => $bs_xinfo_owner.'.'.$bs_xinfo_XXRTJOB,
                        'col'  => array (
                            'XXRDATCLIENT' => 'XXRDATCLIENT',      // Client
                            'XXRDATENV'    => 'XXRDATENV',         // Environment
                            'XXRDATINFO'   => 'XXRDATINFO',        // DatAddInfo
                            'JOBLIB'       => 'JOBLIB',            // JCL-Lib
                            'JOBMEMB'      => 'JOBMEMB',           // Member
                            'JOBJN'        => 'JOBJN'              // Jobname
                        )
                    ),
                    
                    '*' => array (
                        /*                        
                        'system' => array (
                            'XXRDATCLIENT' => 'CLIENT1',
                            'XXRDATENV'    => 'ENV1',
                            'XXRDATINFO'   => 'INFO1'
                        )
						*/                       

                        'conn' => array (
                            'host' => '',
                            'port' => '',
                            'schema' => '',
                            'type' => 'db2',
                            'alias' => 'DALLAS9',
							'user' => $bs_xinfo_user,
							'pwd' => $bs_xinfo_psw
                        )
					)
                )
            )
        )
    ),	

    /*
     *  enable/disable pager and set its size
     */
        'pager' => array(
            'page_size'  => 30,
            'pager_size' => 14,
            'enabled'    => true
        ),


    /* This configures what columns are visible in the file list (selection from the archive) and the order of them.
     * It also allows to specify an action called when a member is clicked, in which case the member name is rendered as a link.
     * Default values are empty strings, which means defaults (all columns and no action)
     * Possible options for grid_member_action (the top grid) are:
     *      empty string - no action
     *      browse       - the member is browsed when clicked
     *      select       - the member (and only this one) is selected and the next task is started
     *      add          - the member is added to the selection
     *      
     * Possible options for sel_member_action (the bottom grid) are:
     *      empty string - no action
     *      browse       - the member is browsed when clicked
     *
     *      order = string with comma separated tokens (in any order): version, group, process_id, status, member, library, system, cre_user, cre_date, cha_user, cha_date
     *      Example: order='version, process_id, status, member, library, system'
     *      Only these 6 columns will be visible in the order in which they appear in 'order' option
     */
        'file_list_columns' => array(
            '*' => array(
                'grid_member_action'   => '',
                'sel_member_action'    => '',
                'order'                => ''
            )
        ),


    /* 
     *  DSN containing job templates on various systems
     *  'template_dsn_cntl' => array (
     *      '<client>' => array (
     *          '<system_id>' => '<dataset name>',
     *          ...
     *      ),
     *      ...
     *  )
     */
		'template_dsn_cntl' => array (
			'*' => array (
				$bs_BAS_id 		=> $bs_BAS_template,
				$bs_PRD_id 		=> $bs_PRD_template,
				$bs_UAT_id 		=> $bs_UAT_template,
				$bs_INT_id 		=> $bs_INT_template,
				$bs_DEV_id 		=> $bs_DEV_template 
			)
		),

    /*  
     *  Prefix of temporary datasets created by ProcMan
     *   'base_tmp_dsn' => array (
     *       '<client>' => array (
     *           '<system_id>' => '<dataset_prefix>',
     *           ...
     *       ),
     *       ...
     *   )
     */
		'base_tmp_dsn' => array (
			'*' => array (
				$bs_BAS_id 		=> $bs_BAS_base_tmp,
				$bs_PRD_id 		=> $bs_PRD_base_tmp,
				$bs_UAT_id 		=> $bs_UAT_base_tmp,
				$bs_INT_id 		=> $bs_INT_base_tmp,
				$bs_DEV_id 		=> $bs_DEV_base_tmp
			)
		),
    /*
     * enables or disabled the syntax highllighter + set the default syntax
     */
        'syntax_highlighter' => array(
            // available options:
            //    'DISABLED' - don't use it by default, but keep the possibility to turn it on at the page
            //    'WEB'      - use web style
            //    'ISPF'     - use ISPF style
            //    false      - disable it 
            //
            'jcl' => array(
                'view'            => 'WEB',
                'edit'            => 'WEB',
                'max_line_length' => 80
            ),
            'sysin' => array(
                'max_line_length' => 100
            )
        ),
        'syntax_highlighter_combo' => false,

    /*
     *  Substitution (max 8 chars) for ##JOBNAME## in templates
     *  Vars: &userid.      - user id (e.g. P391A)
     *        &userid[1-8]. - substring of user id (e.g. &userid2. ~ P3 or &userid8. ~ P391AXXX {It is complemented from right by X on required size (max 8)})
     *        &procid.      - process id (e.g. 166)
     *        &procid[1-8]. - substring of process id (e.g. &procid1. ~ 1 or &procid5. ~ 00166 {It is complemented from left by 0 on required size (max 8)})
     *        &suffix.      - generated 1 char
     * 
     *        the last variable in string can be without a dot
     * 
     *  E.g.: &userid. ~ P391A, &procid. ~ 166, &suffix. ~ W  
     *        1) 'jobname_format' => '$&userid.&suffix'          ~ $P391AW
     *        2) 'jobname_format' => 'TEST&suffix.&procid3'      ~ TESTW166
     *        3) 'jobname_format' => '&suffix.&procid6.&suffix'  ~ W000166W
     * 
     *  Important: When section jobname_format will be deleted or will be set on empty string, it will be used default format (&userid.&suffix).
     * 
     */
        'jobname_format' => '',

    /*
     *  Duplicate member section
     * 
     *  --format
     *  Substitution for members in duplicating
     *  Vars: &userid.      - user id (e.g. P391A)
     *        &userid[1-8]. - substring of user id (e.g. &userid2. ~ P3 or &userid8. ~ P391AXXX {It is complemented from right by X on required size (max 8)})
     *        &procid.      - process id (e.g. 166)
     *        &procid[1-8]. - substring of process id (e.g. &procid1. ~ 1 or &procid5. ~ 00166 {It is complemented from left by 0 on required size (max 8)})
     *        &suffix.      - generated 1 char
     *        &inc.         - increment
     *        &inc[1-8].    - substring of increment
     *        &member.      - member
     *        &member[1-8]. - substring of member
     *        &var(?).      - hwm variable - example &var(process).
     *        &var(?)[1-8]. - substring of hwm variable - example &var(user)5.
     * 
     *        the last variable in string can be without a dot
     * 
     *  E.g.: &userid. ~ P391A, &procid. ~ 166, &suffix. ~ W, &inc. ~ 12  
     *        1) 'duplicate_member_format' => '$&userid.&suffix'          ~ $P391AW
     *        2) 'duplicate_member_format' => 'TEST&suffix.&procid3'      ~ TESTW166
     *        3) 'duplicate_member_format' => '&suffix.&procid6.&suffix'  ~ W000166W
     *        4) 'duplicate_member_format' => 'PO&inc6'                   ~ PO000012
     * 
     *  Important: When section duplicate_member_format will be deleted or will be set on empty string, it will be used default format (DUP&inc5).
     * 
     * --automatically_filled
     * Number of automatically filled substituted member names
     * default - 0
     * 
     * --silent
     * automatically sending of form
     * default - false
     * 
     * Important: silent works only with automatically_filed > 0
     * 
     */
        'duplicate_member' => [
            'format'                => 'D&member5.&inc2',
            'automatically_filled'  => 1,
            'silent'                => false

        ],

    /*	
	 * defines the separator used in JUPJCLO. 
	 * the default one (ADD) creates this separator header: ./ADD MEMBER=....
	 */
        'member_separator' => ' ADD',


    /*
	 * define passwords which overwrite passwords set in zos_tech_user
	 * syntax:
	 *	'passwords' => array (
	 *	    array ('sys' => 'SYS_ID',
	 *	           'usr' => 'TECHUSR',
	 *		       'pwd' => 'TECHUSR_PWD')
	 *      ) 
	 *   )
	 */
        'passwords' => array(),

    /*
     * Deleting or keeping archive files (JCL, PROC, SYSIN) when deleting completed processes
     * available options:
     *  true  - it deletes automatically archive files from archive JCL, PROC, SYSIN
     *  false - it keeps automatically archive files in archive JCL, PROC, SYSIN
     *  'ASK' - the user decides whether deletes or keeps from/in archive JCL, PROC, SYSIN
     * 
     * if this section isn't set, then it is set as default: ASK
     */
        'remove_from_archive_on_delete' => 'ASK',

    /*
     * Processing of members (downloading, uploading, etc.) 
     * - only for modules and interfaces that support it
     * - for example - i_file_list
     * available options:
     *    - serial
     *    - parallel 
     */
        'member_processing_method' => 'serial',

    /*
     * Reloads the environment after loading the save point (it set to true)
     * If env was changed, to make it working for interrupted processes, too (not only for new processes)
     */
        'reload_environment' => true,

    /*
     * Method for transferring
     * - only for modules and interfaces that support it (now only for TSO export and TSO import)
     * - default - false
     * 
     * actions (read, export, import)   
     * - true  - if there is more than one member, members are transferred via PS file
     * - false - each members are transferred independently  
     * threshold
     * - for using fast method from X members
     * - if not used, the default is 5
     */
        'ps_transfer' => array(
            '*' => array(                       // SystemId
                '*' => array(                   // Request
                    'actions'   => array(
                        'read'      => true,
                        'export'    => true,
                        'import'    => true
                    ),
                    'threshold' => 5           // if 5 or more members 
                )
            )
        )
    )
);
