<?php
$hwm_autoexec_config = array(
    /*
     * Communication ID from the etc/hwm_universal_interface_config.php
     * file. It is the name of the communication configuration used for
     * the autoexecution of activities.
     *
     * This parameter is mandatory!
     *
     * This parameter is general only and cannot be overriden in 'actions' (see
     * below).
     */
    'communication' => 'autoexec_activity',

    /*
     * User ID of the user which is used as submitter of the automatic actions.
     * The user must be defined in HWM and have a proper role for executing
     * the automatic actions.
     *
     * This parameter is mandatory!
     */
    'user' => 'autoexec',

    /*
     * Password of the user above. The password must be in form encrypted by
     * the HWM Encryption tool (Admin dialog).
     *
     * This parameter is optional and must be specified only if the automatic
     * actions require it. If not needed it can be omitted or set to an empty
     * string.
     */
    'password' => '==Fd3GMfl9gXK4oJVnp5F7QAWnUzVX1M178rLPq/NVqPaZ+NbO2w1MWCYH2XeG',

    /*
     * Whether the recalled activities shall be considered for the
     * autoexecution.
     */
    'recalled' => 'Y',

    /*
     * Specifies whether the general process data section is initialy
     * expanded or collapsed in the dialog.
     */
    'display_gpd_expanded' => 'Y',

    /*
     * Specifies whether the additional process data section is initialy
     * expanded or collapsed in the dialog.
     */
    'display_apd_expanded' => 'Y',

    /*
     * Specifies whether the memo history section is initialy expanded or
     * collapsed in the dialog.
     */
    'display_mh_expanded' => 'Y',

    /*
     * Definition of possible rejects. It is an array of single reject
     * definitions, like this:
     *   array(<description>, <return code> [, <translate> ])
     * <description> is a string, it is either the description or a
     *       dictionary key.
     * <return code> is a string, it specified the return code of the
     *       activity if the definition has been selected for rejection.
     * <translate> is a string, is optional, if the value is 'Y' or 'y'
     *       the <description> is handled as a dictionary key, otherwise
     *       it is not translated, which is also the default.
     *
     * If rejects are not specified, or set to an empty array, the rejection
     * of activities is switched off.
     */
    'rejects' => array(
        array('hwm_mReject', '1', 'Y'),
    ),

    /*
     * Specifies whether the action has to be called on reject or not. Some
     * autoexec activities (e.g. ProcMan's JCL/IWS activities) require, that
     * the action is called also at reject, to perform some internal operations,
     * before the activities are rejected.
     */
    'action_call_on_reject' => 'N',

    /*
     * Specifies how many automatic activities can be started in parallel. The
     * value can be an integer from interval <1, 20>. Values < 1 are adjusted
     * to 1, values > 20 are adjusted to 20. Default is 1.
     *
     * !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     * BEWARE that too many parallel activities sharing slow blocking resources,
     * which can be used only by one activity at a time (e.g. locked DB tables),
     * may cause situations, where some activities have to wait too long for
     * resources used by other activities, so they may run in timeout errors.
     * Thus select and test the value for this option carefully, before you use
     * it in a productive environment.
     * !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     */
    'max_parallel_activities' => 1,
    
    /*
     * If different settings shall be used for different automatic actions, they
     * can be specified in actions (see examples below) where the action key
     * is either the complete action id or an action id pattern and the value
     * contains 'user', 'password' and 'rejects' options with the same syntax
     * and semantic like the general options above. In the action id patterns
     * wildcards * (any string) and ? (any character) can be used. If several
     * patterns matching the executed activity the settings for the first
     * matching key are used.
     */
    /*
    'actions' => array(
        'AUTOEXEC_*_2' => array(
            'user' => 'auto_user2',
            'password' => '=MYhVs2EptYY7yqW3l8+j6yeQkywxLpJkzRWfaDtFUOKc/e3u8M5e6A==',
            'rejects' => array(),
        ),
    
        'AUTOEXEC_*_3' => array(
            'user' => 'auto_user3',
            'password' => '',
            'rejects' => array(
                array('DEVELOPER', '1'),
                array('PLANER', '2'),
            ),
            'action_call_on_reject' => 'Y',
        ),
        '*CTM*' => array(
            'action_call_on_reject' => 'Y',
        ),
    ),
     */
    'actions' => array(
        'IWS_*_PRO_UPD' => array(
            'rejects' => array(
                array('Request', '1'),
                array('BAS', '2'),
            ),
            'action_call_on_reject' => 'Y',
        ),	 
        'JCL_*_PRO_UPD' => array(
            'rejects' => array(
                array('Request', '1'),
                array('BAS', '2'),
            ),
            'action_call_on_reject' => 'Y',
        ),	 		
    ),
	 
	 
	 
);
?>
